#pragma once
#include <QDebug>
#include <QDateTime>
#include <iostream>
#include <QThread>
#include <QtMqtt/qmqttclient.h>
#include "common.h"
#include "SyncQueue.h"

class _MqttSendInfo
{
public:
    int MsgID;
    QString timecost;

    _MqttSendInfo()
    {
        
    }
};

class threadSendMqtt : public QThread {
public:
    QString ip;
    int port;
    int num = 0;

    threadSendMqtt(QObject* o = nullptr) :QThread(o)
    {
        isLoop = true;
    }

    ~threadSendMqtt()
    {
        stop();
        _MqttSendInfo TCPSendInfo;
        Local_MQTT_Info_queue->put(TCPSendInfo);
        quit();
        wait();
    }
    void stop();
    bool connectTCP();

protected:
    void run();

public:
    void init(SyncQueue<_MqttSendInfo>* p_MQTT_Info_queue, std::string ip_, int port_);
    void start_work();
    void sendData(_MqttSendInfo* TCPSendInfo, int Num);

public:
    SyncQueue<_MqttSendInfo>* Local_MQTT_Info_queue;
    std::atomic_bool isLoop = { 0 };
    QMqttClient* m_client = NULL;
};
